						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

File_GetNames			PROC

						push	OFFSET szFileName
						push	OFFSET szDirectory
						call	lstrcpy

;	=== Rcuprer le chemin ===

						movzx	eax,Word Ptr [Ofn.nFileOffset]
						mov		Dword Ptr [eax + OFFSET szDirectory],0	; Le nom du dossier est termin par '\'

;	=== Rcuprer le nom du fichier ===

						push	OFFSET szFileTitle
						push	OFFSET szBaseFileName
						call	lstrcpy

						mov		edi,OFFSET szBaseFileName
						mov		al,'.'
						mov		ecx,MAX_PATH
						repne	scasb
						dec		edi
						mov		DWord Ptr [edi],0							; Supprimer l'extension

						ret
File_GetNames			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

File_OpenInit			PROC

;	================================
;	=== Initialisations diverses ===
;	================================

						xor		eax,eax

						mov		edi,DWord Ptr [lpdwColors]

						test	edi,edi
						jz		File_OpenInit_Exit

						mov		ecx,01000000h / SIZEOF DWord
						rep		stosd

File_OpenInit_Exit :

						ret
File_OpenInit			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

File_InitMenus			PROC	hWnd:HWND

						push	DWord Ptr [hWnd]
						call	GetMenu

						mov		esi,eax

						push	MF_BYCOMMAND or MF_ENABLED
						push	IDM_PRIMAIRES_ROUGE
						push	esi
						call	EnableMenuItem

						push	MF_BYCOMMAND or MF_ENABLED
						push	IDM_PRIMAIRES_VERT
						push	esi
						call	EnableMenuItem

						push	MF_BYCOMMAND or MF_ENABLED
						push	IDM_PRIMAIRES_BLEU
						push	esi
						call	EnableMenuItem

						push	MF_BYCOMMAND or MF_ENABLED
						push	IDM_SECONDAIRES_JAUNE
						push	esi
						call	EnableMenuItem

						push	MF_BYCOMMAND or MF_ENABLED
						push	IDM_SECONDAIRES_CYAN
						push	esi
						call	EnableMenuItem

						push	MF_BYCOMMAND or MF_ENABLED
						push	IDM_SECONDAIRES_MAGENTA
						push	esi
						call	EnableMenuItem

						push	MF_BYCOMMAND or MF_ENABLED
						push	IDM_TRANCHES_ORIGINAL
						push	esi
						call	EnableMenuItem

						ret
File_InitMenus			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

File_Open				PROC	USES EBX EDI ESI,hWnd:HWND

						push	OFFSET Ofn
						call	GetOpenFileName			; Slection du fichier  traiter 

						test	eax,eax
						jz		File_Open_Exit			; Aucun fichier slectionn

						call	File_OpenInit			; Initialisation des variables
						call	File_GetNames			; Obtention des diffrents noms de fichier
						call	File_FreeMemory			; librer la mmoire utilise par l'image prcdente

;	===========================
;	=== Prparer le fichier ===
;	===========================

						push	OFFSET szFileName
						push	DWord Ptr [hWnd]
						call	BmpView_CreateBitmap

						test	eax,eax
						jz		File_Open_Exit

;	=======================================
;	=== Modifier le titre de la fentre ===
;	=======================================

						push	DWord Ptr [dwColorsCount]
						push	OFFSET szBaseFileName
						push	OFFSET szFmtWindowTitle
						push	OFFSET szWindowTitle
						call	wsprintf 

						add		esp,16

						push	OFFSET szWindowTitle
						push	DWord Ptr [hWnd]
						call	SetWindowText 

;	==========================================
;	=== Dimensionner la fentre principale ===
;	==========================================

						push	DWord Ptr [hWnd]
						call	Window_SetDim

;	=============================
;	=== Initialiser les menus ===
;	=============================

						push	DWord Ptr [hWnd]
						call	File_InitMenus

;	========================================
;	=== Forcer le redessin de la fentre ===
;	========================================

						push	TRUE
						push	NULL
						push	DWord Ptr [hWnd]
						call	InvalidateRect

						xor		eax,eax
						inc		eax

File_Open_Exit :

						ret
File_Open				ENDP

