						.Code

;wParam			The low-order word specifies whether the window is being activated or deactivated.
;				This parameter can be one of the following values.
;				The high-order word specifies the minimized state of the window being activated or deactivated.
;				A nonzero value indicates the window is minimized. 

;				WA_ACTIVE		Activated by some method other than a mouse click (for example, by a call to the SetActiveWindow function or by use of the keyboard interface to select the window).
;				WA_CLICKACTIVE	Activated by a mouse click.
;				WA_INACTIVE		Deactivated.
;
;lParam			Handle to the window being activated or deactivated, depending on the value of the wParam parameter. If the low-order word of wParam is WA_INACTIVE, lParam is the handle to the window being activated. If the low-order word of wParam is WA_ACTIVE or WA_CLICKACTIVE, lParam is the handle to the window being deactivated. This handle can be NULL. 

Main_WmActivate			PROC	hWnd:HWND,wParam:WPARAM,lParam:LPARAM

						movzx	eax,Word Ptr wParam

						push	DWord Ptr lParam		; Handle to the window being activated
						push	DWord Ptr hWnd			; Handle of the current window
						push	OFFSET Main_WmActivate_Exit

						cmp		eax,WA_ACTIVE
						je		Main_WmActivate_WaActive

						cmp		eax,WA_CLICKACTIVE
						je		Main_WmActivate_WaClickActive

;	WA_INACTIVE

						jmp		OnWaInActive

Main_WmActivate_WaClickActive :

						jmp		OnWaClickActive

Main_WmActivate_WaActive :

						jmp		OnWaActive

Main_WmActivate_Exit :

						xor		eax,eax
						ret
Main_WmActivate			ENDP
