						.Code

Main_WmPaint			PROC	USES EBX EDI ESI,hWnd:HWND

;	*************************
;	*** Variables Locales ***
;	*************************

						LOCAL	rc:RECT
						LOCAL	lpRc:Ptr RECT
						LOCAL	hBmp:HBITMAP
						LOCAL	hBmpOld:HBITMAP

;	*****************************************************************************
;	*** Sauver l'adresse de la variable contenant la taille de la zone client ***
;	*****************************************************************************

						lea		eax,rc						; Adresse de la zone client
						mov		DWord Ptr lpRc,eax

;	*******************************************
;	*** Obtenir la taille de la zone client ***
;	*******************************************

						push	eax							; Adresse de la zone client
						push	DWord Ptr [hWnd]			; Handle de la fentre
						call	GetClientRect 

;	***********************************************
;	*** Dbut du traitement du message WM_PAINT ***
;	***********************************************

						push	OFFSET Ps					; Adresse de la structure PAINTSTRUCT
						push	DWord Ptr [hWnd]			; Handle de la fentre
						call	BeginPaint 

;	*********************************
;	*** A-t-on pu rcuprer un DC ***
;	*********************************

						test	esi,esi
						jz		Main_WmPaint_Exit			; Impossible d'obtenir le DC

;	************************************
;	*** Sauver le DC obtenu dans ESI ***
;	************************************

						mov		esi,eax						; Handle du DC de la fentre

;	**********************************************
;	*** Crer un DC pour le travail en mmoire ***
;	**********************************************

						push	eax							; Handle du DC de la fentre
						call	CreateCompatibleDC

						test	eax,eax
						jz		Main_WmPaint_End			; Pas de DC disponible

						mov		edi,eax						; Sauver le handle du DC Mmoire

;	***********************************************
;	*** Crer un bitmap de la taille de l'cran ***
;	***********************************************

						push	DWord Ptr rc.bottom			; Hauteur
						push	DWord Ptr rc.right			; Largeur
						push	esi							; Handle du DC de la fentre
						call	CreateCompatibleBitmap

						test	eax,eax						; Cration du bitmap impossible
						jz		Main_WmPaint_01

;	*****************************************************
;	*** Sauver le handle du bitmap venant d'tre cr ***
;	*****************************************************

						mov		DWord Ptr [hBmp],eax		; Sauver le handle du bitmap cr

;	*************************************************
;	*** Slectionner le bitmap dans le DC Mmoire ***
;	*************************************************

						push	eax							; Handle du bitmap
						push	edi							; Handle du DC mmoire
						call	SelectObject

						test	eax,eax
						jz		Main_WmPaint_02				; Slection du bitmap impossible

;	****************************************************
;	*** Sauver l'ancien bitmap affect au DC Mmoire ***
;	****************************************************

						mov		DWord Ptr [hBmpOld],eax		; Handle du bitmap prcdent

;	***************************************************************
;	*** Remplir le bitmap avec la couleur du fond de la fentre ***
;	***************************************************************

						push	DWord Ptr [wc.hbrBackground]; Couleur du fond
						push	DWord Ptr lpRc				; Adresse de la zone client
						push	esi							; Handle du DC Mmoire
						call	FillRect

;	***********************************************************************
;	*** Appeler la fonction utilisateur charge du dessin de la fentre ***
;	***********************************************************************

						push	esi							; Handle du DC Mmoire
						push	DWord Ptr [hWnd]			; Handle de la fentre
						call	OnWmPaint

;	************************************
;	*** Slectionner l'ancien bitmap ***
;	************************************

						push	DWord Ptr [hBmpOld]			; Handle de l'ancient bitmap
						push	edi							; Handle du DC Mmoire
						call	SelectObject

Main_WmPaint_02 :

;	*****************************
;	*** Destruction du bitmap ***
;	*****************************

						push	DWord Ptr [hBmp]			; Handle du bitmap cr
						call	DeleteObject

Main_WmPaint_01 :

;	*********************************
;	*** Destruction du DC Mmoire ***
;	*********************************

						push	edi							; Handle du DC Mmoire
						call	DeleteDC

Main_WmPaint_End :

;	************************************
;	*** Dessin de la fentre termin ***
;	************************************

						push	OFFSET Ps
						push	DWord Ptr [hWnd]
						call	EndPaint

Main_WmPaint_Exit :

;	**************************
;	*** Fin de la fonction ***
;	**************************

						ret
Main_WmPaint			ENDP
