						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Colors_GetDispInfo		PROC	hWnd:HWND,lpLvi:PTR LVITEM,dwHexa:DWord
						LOCAL	dwColor:DWord
						LOCAL	dwCount:DWord

						mov		edi,DWord Ptr [lpLvi]

						mov		eax,DWord Ptr (LVITEM Ptr [edi]).imask
						and		eax,LVIF_TEXT
						jz		Colors_GetDispInfo_Exit

						cmp		DWord Ptr [dwHexa],TRUE
						je		Colors_GetDispInfo_Hexa

						mov		esi,OFFSET szFmtDecimal
						jmp		Colors_GetDispInfo_1

Colors_GetDispInfo_Hexa :

						mov		esi,OFFSET szFmtHexaDecimal

Colors_GetDispInfo_1 :

						mov		edx,DWord Ptr (LVITEM Ptr [edi]).lParam

;	1 = Red, 2 = Green, 3 = Blue, 4 = Count

						mov		eax,DWord Ptr (LVITEM Ptr [edi]).iSubItem
						mov		ebx,DWord Ptr (LVITEM Ptr [edi]).pszText

						push	(COLORS_SEARCH Ptr [edx]).dwColor
						pop		DWord Ptr [dwColor]

						push	(COLORS_SEARCH Ptr [edx]).dwCount
						pop		DWord Ptr [dwCount]

						cmp		eax,1
						je		Colors_GetDispInfo_Red

						cmp		eax,2
						je		Colors_GetDispInfo_Green

						cmp		eax,3
						je		Colors_GetDispInfo_Blue

						INVOKE	wsprintf,ebx,ADDR szFmtIndexDecimal,dwCount
						jmp		Colors_GetDispInfo_Exit

Colors_GetDispInfo_Red :

						shr		DWord Ptr dwColor,16
						INVOKE	wsprintf,ebx,esi,dwColor
						jmp		Colors_GetDispInfo_Exit

Colors_GetDispInfo_Green :

						shr		DWord Ptr dwColor,8
						and		DWord Ptr dwColor,0ffh
						INVOKE	wsprintf,ebx,esi,dwColor
						jmp		Colors_GetDispInfo_Exit

Colors_GetDispInfo_Blue :

						and		DWord Ptr dwColor,0ffh
						INVOKE	wsprintf,ebx,esi,dwColor
						jmp		Colors_GetDispInfo_Exit

Colors_GetDispInfo_Exit :

						ret
Colors_GetDispInfo		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

CompareItemsAsc			PROC	lParam1:PTR COLORS_SEARCH,lParam2:PTR COLORS_SEARCH,dwOrdre:LPARAM

						mov		eax,DWord Ptr [dwOrdre]
						mov		ebx,DWord Ptr [lParam1]
						mov		ecx,DWord Ptr [lParam2]

;	==============================================================
;	=== 0 = Index, 1 = Rouge, 2 = Vert, 3 = Bleu, 4 = Compteur ===
;	==============================================================

						test	eax,eax
						jz		CompareItemAsc_Index

						cmp		eax,1
						je		CompareItemAsc_Rouge

						cmp		eax,2
						je		CompareItemAsc_Vert

						cmp		eax,3
						je		CompareItemAsc_Bleu

CompareItemAsc_Compteur :

						mov		eax,DWord Ptr (COLORS_SEARCH Ptr [ebx]).dwCount
						mov		edx,DWord Ptr (COLORS_SEARCH Ptr [ecx]).dwCount

						cmp		eax,edx
						je		CompareItemsAsc_Equal

						cmp		eax,edx
						jl		CompareItemsAsc_Less

						jmp		CompareItemsAsc_Sup

CompareItemAsc_Bleu :

						mov		eax,DWord Ptr (COLORS_SEARCH Ptr [ebx]).dwBlue
						mov		edx,DWord Ptr (COLORS_SEARCH Ptr [ecx]).dwBlue

CompareItemAsc_Bleu_1 :

						cmp		eax,edx
						je		CompareItemsAsc_Equal

						cmp		eax,edx
						jl		CompareItemsAsc_Less

CompareItemsAsc_Sup :

						xor		eax,eax
						inc		eax
						jmp		CompareItemsAsc_Exit

CompareItemAsc_Vert :

						mov		eax,DWord Ptr (COLORS_SEARCH Ptr [ebx]).dwGreen
						mov		edx,DWord Ptr (COLORS_SEARCH Ptr [ecx]).dwGreen

						jmp		CompareItemAsc_Bleu_1

CompareItemAsc_Rouge :

						mov		eax,DWord Ptr (COLORS_SEARCH Ptr [ebx]).dwRed
						mov		edx,DWord Ptr (COLORS_SEARCH Ptr [ecx]).dwRed

						jmp		CompareItemAsc_Bleu_1

CompareItemAsc_Index :

						mov		eax,DWord Ptr (COLORS_SEARCH Ptr [ebx]).dwIndex
						mov		edx,DWord Ptr (COLORS_SEARCH Ptr [ecx]).dwIndex

						jmp		CompareItemAsc_Bleu_1

CompareItemsAsc_Less :

						mov		eax,-1
						jmp		CompareItemsAsc_Exit

CompareItemsAsc_Equal :

						xor		eax,eax

CompareItemsAsc_Exit :

						ret
CompareItemsAsc			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

CompareItemsProc		PROC	USES EBX EDi ESI,lParam1:PTR COLORS_SEARCH,lParam2:PTR COLORS_SEARCH,dwOrdre:LPARAM

						mov		eax,DWord Ptr [dwOrdre]

						push	eax

						cmp		DWord Ptr [dwSortItems + 4 * eax],TRUE
						je		CompareItems_Ascending

;	==================================================
;	=== Ordre de tri = du plus grand au plus petit ===
;	==================================================

						push	DWord Ptr [lParam1]
						push	DWord Ptr [lParam2]

CompareItemsProc_1 :

						push	OFFSET CompareItemsProc_Exit
						jmp		CompareItemsAsc

;	==================================================
;	=== Ordre de tri = du plus petit au plus grand ===
;	==================================================

CompareItems_Ascending :

						push	DWord Ptr [lParam2]
						push	DWord Ptr [lParam1]
						jmp		CompareItemsProc_1

CompareItemsProc_Exit :

						ret
CompareItemsProc		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Colors_Notify			PROC	USES EBX EDI ESI,hWnd:HWND,dwCtrlId:DWord,lpNmHdr:PTR NMHDR
						LOCAL	dwHexa:DWord

						cmp		DWord Ptr [dwCtrlId],IDC_LIST_01
						jne		Colors_Notify_Exit

						mov		eax,DWord Ptr [lpNmHdr]

						cmp		DWord Ptr (NMHDR Ptr [eax]).code,LVN_GETDISPINFO
						jne		Colors_Notify_NextMsg

						push	eax
						INVOKE	IsDlgButtonChecked,hWnd,IDC_CHECK_01
						pop		ebx

						cmp		eax,BST_CHECKED
						je		Colors_Notify_Checked

						push	FALSE
						jmp		Colors_Notify_1

Colors_Notify_Checked :

						push	TRUE

Colors_Notify_1 :

						lea		eax,(NMLVDISPINFO Ptr [ebx]).item
						push	eax
						push	(NMHDR Ptr [eax]).hwndFrom
						push	OFFSET Colors_Notify_End
						jmp		Colors_GetDispInfo

Colors_Notify_NextMsg :

						cmp		DWord Ptr (NMHDR Ptr [eax]).code,LVN_COLUMNCLICK
						jne		Colors_Notify_End

						mov		edx,DWord Ptr (NMLISTVIEW Ptr [eax]).iSubItem

						cmp		DWord Ptr [dwSortItems + 4 * edx],TRUE
						je		Colors_Notify_NextMsg_1

						mov		DWord Ptr [dwSortItems + 4 * edx],TRUE
						jmp		Colors_Notify_NextMsg_2

Colors_Notify_NextMsg_1 :

						mov		DWord Ptr [dwSortItems + 4 * edx],FALSE

Colors_Notify_NextMsg_2 :

						push	OFFSET CompareItemsProc
						push	DWord Ptr (NMLISTVIEW Ptr [eax]).iSubItem
						push	LVM_SORTITEMS
						push	(NMHDR Ptr [eax]).hwndFrom
						push	OFFSET Colors_Notify_End
						jmp		SendMessage 

Colors_Notify_End :

						xor		eax,eax
						inc		eax
						jmp		Colors_Notify_Exit

Colors_Notify_Exit :

						xor		eax,eax
						ret
Colors_Notify			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
