						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Window_SetDim			PROC	hWnd:HWND
						LOCAL	dwW:DWord
						LOCAL	dwH:DWord
						LOCAL	dwNewWidth:DWord
						LOCAL	dwNewHeight:DWord
						LOCAL	dwLower:DWord
						LOCAL	rcClient:RECT
						LOCAL	rcEcran:RECT
						LOCAL	pt:POINT

;	========================================
;	=== Positionner la fentre  l'cran ===
;	========================================

						push	TRUE
						mov		eax,DWord Ptr [rcWorkArea.bottom]
						sub		eax,DWord Ptr [rcWorkArea.top]
						shr		eax,1
						push	eax
						mov		eax,DWord Ptr [rcWorkArea.right]
						sub		eax,DWord Ptr [rcWorkArea.left]
						shr		eax,1
						push	eax
						push	DWord Ptr [rcWorkArea.top]
						push	DWord Ptr [rcWorkArea.left]
						push	DWord Ptr [hWnd]
						call	MoveWindow

;	===================================================
;	=== Obtenir les coordonnes ECRAN de la fentre ===
;	===================================================

						lea		eax,rcEcran

						push	eax
						push	DWord Ptr [hWnd]
						call	GetWindowRect 

;	======================================================================
;	=== Obtenir la position  l'cran du point (0,0) de la zone client ===
;	======================================================================

						lea		eax,pt

						mov		DWord Ptr [pt.x],0
						mov		DWord Ptr [pt.y],0

						push	eax
						push	DWord Ptr [hWnd]
						call	ClientToScreen

;	==================================================
;	=== Calculer la taille des bordures verticales ===
;	==================================================

						mov		eax,DWord Ptr [pt.x]
						sub		eax,DWord Ptr [rcEcran.left]
						shl		eax,1
						mov		DWord Ptr [dwW],eax

;	============================================================
;	=== Calculer la taille de la bordure horizontale du haut ===
;	=== et de la barre de titre de la fentre                ===
;	============================================================

						mov		eax,DWord Ptr [pt.y]
						sub		eax,DWord Ptr [rcEcran.top]
						mov		DWord Ptr [dwH],eax

;	===========================================
;	=== Obtenir la taille de la zone client ===
;	===========================================

						lea		eax,rcClient

						push	eax
						push	DWord Ptr [hWnd]
						call	GetClientRect

;	=================================================================
;	=== Calcul des coordonnes du dernier point de la zone client ===
;	=================================================================

						mov		eax,DWord Ptr [rcClient.right]
						dec		eax
						mov		DWord Ptr [pt.x],eax

						mov		eax,DWord Ptr [rcClient.bottom]
						dec		eax
						mov		DWord Ptr [pt.y],eax

						lea		eax,pt

						push	eax
						push	DWord Ptr [hWnd]
						call	ClientToScreen

						mov		eax,rcEcran.bottom
						sub		eax,DWord Ptr [pt.y]
						add		DWord Ptr [dwH],eax

;	=========================================================================================
;	=== Calcul de la taille de l'image de faon  ce qu'elle tienne dans la zone client   ===
;	=== Cette taille prend en compte le rapport entre la largeur et la hauteur de l'image ===
;	=== Cette technique permet de conserver les proportions de la nouvelle image          ===
;	=========================================================================================

;	===========================================================
;	=== Si l'image est horizontale (W > H) => H = W / Ratio ===
;	=== Si l'image est verticale   (H > W) => W = H * Ratio ===
;	===========================================================

						mov		eax,DWord Ptr [Image.bmWidth]

						cmp		eax,DWord Ptr [Image.bmHeight]
						jg		Window_SetDim_Horizontale

;	=================================================================
;	=== Calcul de la largeur de l'image en fonction de sa hauteur ===
;	=================================================================

Window_SetDim_Verticale :

						fild	DWord Ptr [rcClient.bottom]
						fmul	QWord Ptr [dwImageRatio]

						fist	DWord Ptr dwNewWidth

						mov		eax,DWord Ptr [rcClient.bottom]
						mov		DWord Ptr [dwNewHeight],eax
						jmp		Window_SetDim_Control

;	=================================================================
;	=== Calcul de la hauteur de l'image en fonction de sa largeur ===
;	=================================================================

Window_SetDim_Horizontale :

						fild	DWord Ptr [rcClient.right]
						fmul	QWord Ptr [dwImageRatio]

						fist	DWord Ptr [dwNewHeight]

						mov		eax,DWord Ptr [rcClient.right]
						mov		DWord Ptr [dwNewWidth],eax

;	=====================================================
;	=== Si l'image est presque carre, il se peut que ===
;	=== l'une des deux coordonnes soit fausse        ===
;	=====================================================

Window_SetDim_Control :

;	=======================================================================
;	=== Exemple : Largeur = 768 et Hauteur = 766 => Ratio = 0.997395833 ===
;	=== Le ratio est proche de 1                                        ===
;	=== Dans ce cas, il faut prendre la plus petite dimension entre la  ===
;	=== largeur et la hauteur de la zone client                         ===
;	=======================================================================

;	=============================================================================
;	=== Pour dterminer si le ratio est de 1, je propose la mthode suivante  ===
;	=== Diviser la largeur par 10 puis la multiplier  nouveau par 10         ===
;	=== Faire la mme chose avec la hauteur                                   ===
;	=== Dans le cas prcdent, nous aurions une largeur de 760 et une hauteur ===
;	=== de 760, les deux tant identiques, le ratio est de 1.                 ===
;	=============================================================================

;	=======================================
;	=== Calcul de la largeur corrective ===
;	=======================================

						xor		edx,edx

						mov		eax,DWord Ptr [Image.bmWidth]
						mov		ebx,10
						div		bx

						xor		edx,edx
						mul		bx

						mov		ecx,eax

;	=======================================
;	=== Calcul de la hauteur corrective ===
;	=======================================

						xor		edx,edx

						mov		eax,DWord Ptr [Image.bmHeight]
						mov		ebx,10
						div		bx

						xor		edx,edx
						mul		bx

;	====================================================
;	=== Comparaison des deux dimmensions correctives ===
;	====================================================

						sub		eax,ecx						; Si le rsultat est  0
						jnz		Window_SetDim_Continue		; Le ration est de 1

;	===============================================================
;	=== Prendre la dimension la plus petite entre la largeur et ===
;	=== la hauteur de la zone client                            ===
;	===============================================================

						mov		eax,DWord Ptr rcClient.right
						mov		edx,DWord Ptr rcClient.bottom
						cmp		eax,edx
						cmovge	eax,edx
						mov		DWord Ptr [dwLower],eax

						mov		eax,DWord Ptr [Image.bmWidth]

						cmp		eax,DWord Ptr [Image.bmHeight]
						jg		Window_SetDim_AdjustHorizontale

;	=================================================================
;	=== Calcul de la largeur de l'image en fonction de sa hauteur ===
;	=================================================================

Window_SetDim_AdjustVerticale :

						fild	DWord Ptr [dwLower]
						fmul	QWord Ptr [dwImageRatio]

						fist	DWord Ptr dwNewWidth

						mov		eax,DWord Ptr [dwLower]
						mov		DWord Ptr [dwNewHeight],eax

						jmp		Window_SetDim_Verify

;	=================================================================
;	=== Calcul de la hauteur de l'image en fonction de sa largeur ===
;	=================================================================

Window_SetDim_AdjustHorizontale :

						fild	DWord Ptr [dwLower]
						fdiv	QWord Ptr [dwImageRatio]

						fist	DWord Ptr [dwNewHeight]

						mov		eax,DWord Ptr [dwLower]
						mov		DWord Ptr [dwNewWidth],eax

Window_SetDim_Verify :

;	==========================================================
;	=== Si l'image est carre les dimensions de la fentre ===
;	=== sont identiques alors qu'elles ne devraient pas    ===
;	=== Il faut rechercher la dimension la plus grande de  ===
;	=== l'image, en cas d'galit, il ne faut rien faire.  ===
;	==========================================================

						mov		eax,DWord Ptr [Image.bmWidth]

						cmp		eax,DWord Ptr [Image.bmHeight]	; Ne rien faire les dimensions
						je		Window_SetDim_Continue			; sont identiques

						cmp		eax,DWord Ptr [Image.bmHeight]
						jg		Window_SetDim_Width

Window_SetDim_Height :

						push	TRUE
						mov		eax,DWord Ptr [dwNewHeight]
						add		eax,DWord Ptr [dwH]
						push	eax									; Hauteur
						mov		eax,DWord Ptr [dwLower]
						jmp		Window_SetDim_Common

Window_SetDim_Width :

						push	TRUE
						mov		eax,DWord Ptr [dwLower]
						add		eax,DWord Ptr [dwH]
						push	eax									; Hauteur
						mov		eax,DWord Ptr [dwNewWidth]
						jmp		Window_SetDim_Common

;	====================================================
;	=== Calcul de la taille dfinitive de la fentre ===
;	====================================================

Window_SetDim_Continue :

						push	TRUE
						mov		eax,DWord Ptr [dwNewHeight]
						add		eax,DWord Ptr [dwH]
						push	eax									; Hauteur
						mov		eax,DWord Ptr [dwNewWidth]

Window_SetDim_Common :

						add		eax,DWord Ptr [dwW]
						push	eax									; Largeur
						push	DWord Ptr [rcWorkArea.top]			; Y
						push	DWord Ptr [rcWorkArea.left]			; X
						push	DWord Ptr [hWnd]
						call	MoveWindow

Window_SetDim_Exit :

						push	DWord Ptr [hWnd]
						call	UpdateWindow

						ret
Window_SetDim			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
